#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "dfbiterm.h"
#include <directfb.h>

static int
vt_report_button(int down, int button, int qual, int x, int y)
{
	char mouse_info[16];

	if (y>=0) {
		mouse_info[0]=0;
		snprintf(mouse_info, sizeof(mouse_info), "\033[M%c%c%c",
							(down?(' ' + ((button - 1)&7)):(' '+3)) | /* 0 = lmb, 1 = mid, 2 = rmb, 3 = up */
							((qual&1)?4:0) | /* shift */
							((qual&8)?8:0) | /* meta */
							((qual&4)?16:0), /* control */
							x+' '+1,
							y+' '+1);
		if (mouse_info[0]) {
			write(pIterm->fd, mouse_info, strlen(mouse_info));
			return 1;
		}
	}
	return 0;
}

void
term_handle_button(DFBWindowEvent *evt)
{
	int button, down, qual = 0;

	if (evt->type == DWET_BUTTONDOWN || evt->type == DWET_BUTTONUP) {
		switch (evt->button) {
			case DIBI_LEFT:
				button = 1;
				break;
			case DIBI_MIDDLE:
				button = 2;
				break;
			case DIBI_RIGHT:
				button = 3;
				break;
			default:
				return;
		}
	} else if (evt->type == DWET_WHEEL) {
		if (evt->step > 0) button = 4;
		else button = 5;
	}

	down = (evt->type == DWET_BUTTONDOWN || evt->type == DWET_WHEEL);

	if (evt->modifiers & DIMM_SHIFT)
		qual |= 1;
	if (evt->modifiers & DIMM_CONTROL)
		qual |= 4;
	if (evt->modifiers & DIMM_ALT) /* meta? */
		qual |= 8;

	evt->x /= pIterm->cell_width;
	evt->y /= pIterm->cell_height;

	if (!(evt->modifiers & DIMM_SHIFT)) vt_report_button(down, button, qual, evt->x, evt->y);
}
